Тестирование
=====

## Определения тестирования

* процесс выполнения программы с целью нахождения ошибок
* интеллектуальная дисциплина, имеющая целью получение надежного программного обеспечения без излишних усилий на его проверку
* техническое исследование программы для получения информации о её качестве с точки зрения определенного круга заинтересованных лиц (С. Канер)
* проверка соответствия между реальным поведением программы и её ожидаемым поведением на конечном наборе тестов, выполненных определенным образом
* процесс наблюдения за выполнением программы в специальных условиях и вынесения на этой основе оценки каких либо аспектов её работы
* процесс, имеющий целью выявление ситуаций, в которых поведение программы является неправильным, нежелательным или не соответствующим спецификации
* процесс, содержащий в себе все активности жизненного цикла, как динамические, так и статические, касающиеся планирования, подготовки и оценки программного продукта и связанных с этим результатов работ с целью определить, что они соответствуют описанным требованиям, показать, что они подходят для заявленных целей и для определения дефектов

## Классификации видов и методов тестирования

### По объекту тестирования

* Функциональное тестирование
* Тестирование производительности
	* Нагрузочное тестирование
	* Стресс-тестирование
	* Тестирование стабильности
* Конфигурационное тестирование
* Юзабилити-тестирование
* Тестирование интерфейса пользователя
* Тестирование безопасности
* Тестирование локализации
* Тестирование совместимости
		
### По знанию внутреннего строения системы

* Тестирование чёрного ящика
* Тестирование белого ящика
* Тестирование серого ящика

### По степени автоматизации

* Ручное тестирование
* Автоматизированное тестирование
* Полуавтоматизированное тестирование

### По степени изолированности

* Тестирование компонентов
* Интеграционное тестирование
* Системное тестирование

### По времени проведения тестирования

* Альфа-тестирование
	* Дымовое тестирование (англ. smoke testing)
	* Тестирование новой функции (new feature testing)
	* Подтверждающее тестирование
	* Регрессионное тестирование
	* Приёмочное тестирование
* Бета-тестирование

### По признаку позитивности сценариев

* Позитивное тестирование
* Негативное тестирование

### По степени подготовленности к тестированию

* Тестирование по документации (формальное тестирование)
* Интуитивное тестирование (англ. ad hoc testing)